package me.unurled.sacredrealms.sr.components.cutscene.recording.recordables;

import java.util.UUID;
import me.unurled.sacredrealms.sr.components.cutscene.recording.Recordable;
import net.kyori.adventure.text.Component;
import org.bukkit.Location;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.jetbrains.annotations.NotNull;

public class SpawnEntityRecordable extends Recordable {

  private EntityType entityType;
  private Location location;
  private UUID entityId;
  private Component name;

  public SpawnEntityRecordable() {}

  public SpawnEntityRecordable(@NotNull Entity e) {
    this.entityType = e.getType();
    this.location = e.getLocation();
    this.entityId = e.getUniqueId();
    this.name = e.name();
  }

  public SpawnEntityRecordable(
      EntityType entityType, Location location, UUID entityId, Component name) {
    this.entityType = entityType;
    this.location = location;
    this.entityId = entityId;
    this.name = name;
  }

  @Override
  public void replay() {
    // TODO: fake spawn entity
  }

  public EntityType entityType() {
    return entityType;
  }

  public SpawnEntityRecordable setEntityType(EntityType entityType) {
    this.entityType = entityType;
    return this;
  }

  public Location location() {
    return location;
  }

  public SpawnEntityRecordable setLocation(Location location) {
    this.location = location;
    return this;
  }

  public UUID entityId() {
    return entityId;
  }

  public SpawnEntityRecordable setEntityId(UUID entityId) {
    this.entityId = entityId;
    return this;
  }

  public Component name() {
    return name;
  }

  public SpawnEntityRecordable setName(Component name) {
    this.name = name;
    return this;
  }
}
